const jwtStrategy = require('passport-jwt').Strategy;
const ExtractJwt = require('passport-jwt').ExtractJwt;
const User = require('../models/user');
const RegStudent = require('../models/regstudent').TableModel;
const config = require('../config/database');
const Handler = require('../Helpers/handler');

module.exports = function (passport) {
    let opts = {};
    opts.jwtFromRequest = ExtractJwt.fromAuthHeaderWithScheme("jwt");
    opts.secretOrKey = config.secret;
    passport.use(new jwtStrategy(opts, (jwt_payload, done) => {
        // console.log(jwt_payload);
        User.getUserById(jwt_payload.id, (err, user) => {
            if (err) {
                return done(err, false);
            }
            if (user) {
                return done(null, user);
            } else {
                Handler.getModel('student').TableModel.findOne({ _id: jwt_payload.id }, (err, user) => {
                    if (err) {
                        return done(err, false);
                    }
                    if (user) {
                        return done(null, user);
                    } else {
                        RegStudent.findOne({ _id: jwt_payload.id }, (err, user) => {
                            if (err) {
                                return done(err, false);
                            }
                            if (user) {
                                return done(null, user);
                            } else {
                                return done(null, false);
                            }
                        });
                    }
                })
                // return done(null, false);
            }
        })
    }));
}
// const jwtStrategy = require('passport-jwt').Strategy;
// const ExtractJwt = require('passport-jwt').ExtractJwt;
// const Handler = require('../Helpers/handler');
// const config = require('../config/database');

// module.exports = function (passport) {
//     let opts = {};
//     opts.jwtFromRequest = ExtractJwt.fromAuthHeaderWithScheme("jwt");
//     opts.secretOrKey = config.secret;
//     passport.use(new jwtStrategy(opts, (jwt_payload, done) => {
//         // console.log(jwt_payload);
//         Handler.getModel('student').TableModel.findOne({ _id: jwt_payload.id }, (err, user) => {
//             if (err) {
//                 return done(err, false);
//             }
//             if (user) {
//                 return done(null, user);
//             } else {
//                 return done(null, false);
//             }
//         })
//     }));
// }