const mongoose = require("mongoose");

const TableName = "Batch";

const TableSchema = mongoose.Schema({
    batch_name: {
        type: String,
        trim: true
    },
    batch_code: {
        type: String,
        trim: true
    },
    test_code: {
        type: Array,
        trim: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
