const mongoose = require("mongoose");

const TableName = "Course";

const TableSchema = mongoose.Schema({
    title: {
        type: String
    },
    remark: {
        type: String
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
