const mongoose = require("mongoose");

const TableName = "Institute";

const TableSchema = mongoose.Schema({
    name: { type: String, required: true },
    short_name: { type: String, required: true },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date,
        default: Date.now()
    },
    created_by: {
        type: String,
    },
    updated_at: {
        type: Date,
    },
    updated_by: {
        type: String,
    },
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}


