const mongoose = require("mongoose");

const TableName = "regstudents";

const TableSchema = mongoose.Schema({

  enrollment_number: {
    type: String
  },
  mobile_number: {
    type: String
  },
  email: {
    type: String
  },
  dob: {
    type: String
  },
  real_pass: {
    type: String,
    required: true,
  },
  password: {
    type: String
  },
  name: String,
  father_name: String,
  gender: String,
  course: String,
  branch: String,
  semester: String,
  status: String,
  college_name: String,
  college_code: String,
  exam_form_status: String,
  scheme: String,
  papercode1: String,
  papername1: String,
  papercode2: String,
  papername2: String,
  papercode3: String,
  papername3: String,
  papercode4: String,
  papername4: String,
  papercode5: String,
  papername5: String,
  papercode6: String,
  papername6: String,
  papercode7: { type: String, default: "GU001" },
  papername7: { type: String, default: "Mock Test" },
  uploadedPaper: { type: Array, default: [] },
  ExamformFilledPaper: String,
  created_at: {
    type: Date,
    default: Date.now(),
  },
  updated_at: {
    type: Date,
    default: Date.now(),
  },

});

const Table = (module.exports = mongoose.model(TableName, TableSchema));

// const OldTable = mongoose.model("old" + TableName, TableSchema);

module.exports.addRow = (newRow, callback) => {
  newRow.created_at = Date.now();
  newRow.save(callback);
};

module.exports.getDataByFieldName = (fieldName, fieldValue, callback) => {
  let query = {};
  query[fieldName] = fieldValue;
  Table.find(query, callback);
};

module.exports.updateRow = (id, newData, callback) => {
  newData.updated_at = Date.now();
  Table.findByIdAndUpdate(id, { $set: newData }, callback);
};


// module.exports.getData = (callback) => {
//   Table.find(callback);
// };

// module.exports.getDataById = (id, callback) => {
//   Table.findById(id, callback);
// };

// module.exports.getDataByPosts = (post_id, callback) => {
//   Table.find({
//     posts : post_id
//   }, callback);
// };

// module.exports.fetching_form_fees = (form_name,university_code, callback) => {
//   Table.findOne({
//     form_name : form_name,
//     university_code : university_code
//   }, callback);
// };



// module.exports.getDataByFieldNames = (fieldNames, fieldValues, callback) => {
//   let query = {};
//   for (let i = 0; i < fieldNames.length; i++) {
//     const fieldName = fieldNames[i];
//     const fieldValue = fieldValues[i];
//     query[fieldName] = fieldValue;
//   }
//   Table.find(query, callback);
// };

// module.exports.getSingleDataByFieldName = (fieldName, fieldValue, callback) => {
//   let query = {};
//   query[fieldName] = fieldValue;
//   Table.findOne(query, callback);
// };

// module.exports.getSingleDataByFieldNames = (fieldNames, fieldValues, callback) => {
//   let query = {};
//   for (let i = 0; i < fieldNames.length; i++) {
//     const fieldName = fieldNames[i];
//     const fieldValue = fieldValues[i];
//     query[fieldName] = fieldValue;
//   }
//   console.log(query);
//   Table.findOne(query, callback);
// };

// module.exports.deleteTableById = (id, callback) => {
//   Table.findById(id, (err, doc) => {
//     if (err) {
//       callback(err, null);
//     } else {
//       if (!doc) {
//         callback(err, doc);
//       } else {
//         const dataToDel = new OldTable(doc);
//         OldTable.insertMany(doc)
//           .then((val) => {
//             Table.findByIdAndDelete(id, callback);
//           })
//           .catch((reason) => {
//             callback(reason, null);
//           });
//       }
//     }
//   });
// };
