const mongoose = require("mongoose");

const TableName = "MailInfo";

const TableSchema = mongoose.Schema({
    messageId: {
        type: String,
        trim: true
    },
    info: {
        type: JSON,
        trim: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
