const mongoose = require("mongoose");

const TableName = "OfflineResult";

const TableSchema = mongoose.Schema({
    paper_code: String,
    paper_doc: String,
    teacher: JSON,
    enrollment_number: String,
    student: JSON,
    result: JSON,
    created_at: {
        type: Date,
        default: Date.now(),
    },
    updated_at: {
        type: Date,
        default: Date.now(),
    },

}, {
    writeConcern: {
        w: 'majority',
        j: true,
        wtimeout: 20000
    }
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
