const mongoose = require("mongoose");

const TableName = "QuestionBank";

const TableSchema = mongoose.Schema({
    category: {
        type: String,
        trim: true
    },
    subject_name: {
        type: String,
        trim: true
    },
    course_name: {
        type: String,
        trim: true
    },
    class_name: {
        type: String,
        index: true
    },
    question: {
        type: String,
        trim: true
    },
    question_code: {
        type: String,
        trim: true
    },
    options: {
        type: Array
    },
    is_image: {
        type: String,
        trim: true
    },
    question_hindi: {
        type: String,
        trim: true,
        default: ''
    },
    options_hindi: {
        type: Array,
        default: []
    },
    is_hindi: {
        type: String,
        trim: true,
        default: 'N'
    },
    image_path: {
        type: String
    },
    correct_answer: {
        type: String
    },
    level: {
        type: String,
        index: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

TableSchema.index({ class_name: 1, level: 1, institute_code: 1 });

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
