const mongoose = require('mongoose');

const TableName = "QuestionSeen";

const TableSchema = mongoose.Schema({
    eno: String,
    paper_code: String,
    qid: String,
    institute_code: { type: String, required: true },
    uniqId: {
        type: String,
        index: true
    },
    created_at: {
        type: Date
    },
}, {
    writeConcern: {
        w: 'majority',
        j: true,
        wtimeout: 20000
    }
});

TableSchema.index({ eno: 1, paper_code: 1 });

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
/**
 * * Operations
 * INSERT
 *  */