const mongoose = require("mongoose");

const TableName = "regstudents";

const TableSchema = mongoose.Schema({

    enrollment_number: {
        type: String,
        required: true,
    },
    mobile_number: {
        type: String,
        required: true,
    },
    email: {
        type: String,
        required: true,
    },
    dob: {
        type: String,
        required: true,
    },
    real_pass: {
        type: String,
        required: true,
        default: "",
    },
    password: {
        type: String,
        required: true,
    },
    name: String,
    father_name: String,
    gender: String,
    course: String,
    branch: String,
    semester: String,
    status: String,
    college_name: String,
    college_code: String,
    exam_form_status: String,
    scheme: String,
    papercode1: String,
    papername1: String,
    papercode2: String,
    papername2: String,
    papercode3: String,
    papername3: String,
    papercode4: String,
    papername4: String,
    papercode5: String,
    papername5: String,
    papercode6: String,
    papername6: String,
    papercode7: { type: String, default: "GU001" },
    papername7: { type: String, default: "Mock Test" },
    uploadedPaper: { type: Array, default: [] },
    ExamformFilledPaper: String,
    paymentDT: String,
    created_at: {
        type: Date,
        default: Date.now(),
    },
    updated_at: {
        type: Date,
        default: Date.now(),
    },

}, {
    writeConcern: {
        w: 'majority',
        j: true,
        wtimeout: 20000
    }
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
