const mongoose = require("mongoose");

const TableName = "Result";

const TableSchema = mongoose.Schema({
    exam_id: {
        type: String,
        index: true
    },
    paper_id: {
        type: String,
        index: true
    },
    student_id: {
        type: String,
        index: true
    },
    student: {
        type: JSON,
        index: true
    },
    warnings_left: {
        type: Number,
        default: 0
    },
    last_warning: {
        type: String
    },
    login_attempts: {
        type: Number,
        default: 0
    },
    scoredMarks: {
        type: Number,
        default: 0
    },
    maxMarks: {
        type: Number,
        default: 0
    },
    submitted: {
        type: Boolean,
        default: false,
        index: true
    },
    uniqId: {
        type: String,
        index: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
}, {
    writeConcern: {
        w: 'majority',
        j: true,
        wtimeout: 20000
    }
});

TableSchema.index({ paper_id: 1, "student.enrollment_no": true });

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
