const mongoose = require("mongoose");

const TableName = "Student";

const TableSchema = mongoose.Schema({
    enrollment_no: {
        type: String,
        trim: true,
        index: true
    },
    name: {
        type: String,
        trim: true
    },
    father_name: {
        type: String,
        trim: true,
        default: "zzzzzz",
        index: true
    },
    semester: {
        type: String,
        trim: true
    },
    year: {
        type: String,
        trim: true
    },
    course: {
        type: String,
        trim: true
    },
    branch: {
        type: String,
        trim: true,
        default: ''
    },
    college_name: {
        type: String,
        trim: true
    },
    branch_name: {
        type: String,
        trim: true
    },
    mobile: {
        type: String,
        trim: true
    },
    email: {
        type: String,
        trim: true
    },
    dob: {
        type: String,
        trim: true,
        index: true
    },
    ip: {
        type: String
    },
    photo: {
        type: String,
        trim: true
    },
    signature: {
        type: String,
        trim: true
    },
    subjects: {
        type: Array,
        trim: true,
        default: []
    },
    no_of_sub: {
        type: String,
        trim: true
    },
    batch_code: {
        type: String,
        trim: true,
        index: true
    },
    username: {
        type: String,
        trim: true
    },
    otp: {
        type: String,
        trim: true,
        index: true
    },
    exam_otp: {
        type: String,
        trim: true
    },
    subjects_verified: {
        type: Array,
        trim: true,
        default: []
    },
    exam_url: {
        type: String,
        trim: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    registerationIp: {
        type: String
    },
    isRegistered: {
        type: String,
        default: "N"
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_name: {
        type: String
    },
    institute_code: {
        type: String,
        index: true
    },
    last_update: {
        type: String
    },
    created_at: {
        type: Date,
        default: Date.now()
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String,

}, {
    writeConcern: {
        w: 'majority',
        j: true,
        wtimeout: 20000
    }
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
