const mongoose = require("mongoose");

const TableName = "TestCreation";

const TableSchema = mongoose.Schema({
    test_code: {
        type: String,
        trim: true
    },
    start_time: {
        type: String,
        trim: true
    },
    end_time: {
        type: String,
        trim: true
    },
    status: {
        type: String,
        trim: true
    },
    duration: {
        type: String,
        trim: true
    },
    exam_enable_time: {
        type: String,
        trim: true
    },
    exam_expire_time: {
        type: String,
        trim: true
    },
    test_paper_code: {
        type: String,
        trim: true
    },
    exam_url: {
        type: String,
        trim: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String, required: true },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
