const mongoose = require("mongoose");

const TableName = "TestPaper";

const TableSchema = mongoose.Schema({
    test_paper_code: {
        type: String,
        trim: true,
        index: true
    },
    test_paper_name: {
        type: String,
        trim: true,
        index: true
    },
    subject: {
        type: String,
        trim: true
    },
    warning_time: {
        type: String,
        trim: true
    },
    per_question_time: {
        type: String,
        trim: true
    },
    marking: {
        type: String,
        trim: true
    },
    negative_marking: {
        type: String,
        trim: true
    },
    no_of_question: {
        type: String,
        trim: true
    },
    question_codes: {
        type: Array,
        trim: true
    },
    question_file: {
        type: String,
    },
    take_snap: {
        type: String,
        trim: true,
        default: "Y"
    },
    snap_duration: {
        type: String,
        trim: true,
        default: "300"
    },
    photo_matching: {
        type: String,
        trim: true
    },
    question_of_10: { type: String, default: "0" },
    question_of_9: { type: String, default: "0" },
    question_of_8: { type: String, default: "0" },
    question_of_7: { type: String, default: "0" },
    question_of_6: { type: String, default: "0" },
    question_of_5: { type: String, default: "0" },
    question_of_4: { type: String, default: "0" },
    question_of_3: { type: String, default: "0" },
    question_of_2: { type: String, default: "0" },
    question_of_1: { type: String, default: "0" },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    institute_code: { type: String },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

TableSchema.index({ test_paper_name: 1, institute_code: 1 });

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
