const _router = require("express").Router();
const Handler = require("./../Helpers/handler");
const Mail = require("./../services/mail");
const Templates = require("./../templates/templates");

_router.post('/sendExamUrl', (req, res) => {
    const enrollment_no = req.body.enrollment_no;
    const Student = Handler.getModel("student");
    Student.TableModel.findOne({ enrollment_no }, (err, doc) => {
        if (err) {
            throw err
        } else {
            if (!doc) {
                return res.json({ success: false, msg: "No Registered Student Found" });
            } else {
                mailBody = Templates.getTemplate("examUrl.html");
                mailBody = mailBody.replace("[NAME]", doc.name);
                mailBody = mailBody.replace("[FROM]", "RGPV Exam");
                mailBody = mailBody.replace("[FROM-NAME]", "RGPV");
                mailBody = mailBody.replace("[FROM-INSTITUTE]", "RGPV BHOPAL");
                mailBody = mailBody.replace("[MESSAGE]", `EXAM URL: <a href="https://rgpvexam.in/e/${doc.enrollment_no}/${doc.otp}">https://rgpvexam.in/e/${doc.enrollment_no}/${doc.otp}</a>`);
                Mail.sendMail({ email: doc.email, subject: "RGPV Exam URL", body: mailBody }, (err, doc) => {
                    if (err) {
                        return res.json({ success: false, msg: err.message ? err.message : err });
                    } else {
                        return res.json({ success: true, msg: "Ok", data: { doc } });
                    }
                })
            }
        }
    });
})

_router.post('/sendOtp', async (req, res) => {
    const enrollment_no = req.body.enrollment_no;
    const Student = Handler.getModel("student");
    const OTP = makeid(6);
    await Student.TableModel.updateOne({ enrollment_no }, { $set: { exam_otp: OTP } });
    Student.TableModel.findOne({ enrollment_no }, (err, doc) => {
        if (err) {
            throw err
        } else {
            if (!doc) {
                return res.json({ success: false, msg: "No Registered Student Found" });
            } else {
                mailBody = Templates.getTemplate("examUrl.html");
                mailBody = mailBody.replace("[NAME]", doc.name);
                mailBody = mailBody.replace("[FROM]", "RGPV Exam");
                mailBody = mailBody.replace("[FROM-NAME]", "RGPV");
                mailBody = mailBody.replace("[FROM-INSTITUTE]", "RGPV BHOPAL");
                mailBody = mailBody.replace("[MESSAGE]", `OTP: ${OTP}`);
                Mail.sendMail({ email: doc.email, subject: "RGPV Exam OTP", body: mailBody }, (err, doc) => {
                    if (err) {
                        return res.json({ success: false, msg: err.message ? err.message : err });
                    } else {
                        return res.json({ success: true, msg: "Ok", data: { doc } });
                    }
                })
            }
        }
    });
})

_router.post('/checkOtp', async (req, res) => {
    const enrollment_no = req.body.enrollment_no;
    const Student = Handler.getModel("student");
    const OTP = req.body.OTP;
    Student.TableModel.findOne({ enrollment_no }, (err, doc) => {
        if (err) {
            throw err
        } else {
            if (!doc) {
                return res.json({ success: false, msg: "No Registered Student Found" });
            } else {
                if (OTP == doc.exam_otp) {
                    return res.json({ success: true, msg: "OTP Verification Successful" });
                } else {
                    return res.json({ success: false, msg: "OTP Verification Failed" });
                }
            }
        }
    });
})

module.exports = _router;

function makeid(length) {
    var result = "";
    var characters =
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}
