const express = require("express");
const router = express.Router();
const bcrypt = require("bcryptjs");
const TableModel = require("../models/regstudent").TableModel;
// const TimeTableModel = require("../models/time-table");
const TimeTableModel = require("../models/time-table").TableModel;
const rc = require("../controllers/responseController");
const jwt = require('jsonwebtoken');
const passport = require('passport');
const config = require('../config/database');
const path = require('path');

const uploads3 = require('../services/file-upload');
const { log } = require("console");

const singleUploadS3 = uploads3.uploadPapers3.single('file');

router.post(
  "/verify",
  (req, res) => {
    const enrollment_number = req.body.enrollment_number;
    // const req_mobile_number = req.body.mobile_number;
    // const reqEmail = req.body.email;
    const reqDob = req.body.dob;
    const reqPass = req.body.password;
    TableModel.findOne({ enrollment_number: enrollment_number }, (err, docs) => {
      console.log("enrollment no", enrollment_number);
      console.log("docs", docs);
      if (err) {
        return rc.setResponse(res, {
          msg: err.message,
        });
      } else if (docs) {
        let studentata = docs;
        var isVerified = false;
        var t_user = {
          id: studentata._id,
          enrollment_no: studentata.enrollment_no,
          dob: studentata.dob
        };
        const token = jwt.sign(t_user, config.secret, {
          expiresIn: 10800
        });

        if (studentata.dob == reqDob) {
          isVerified = true;
          TableModel.updateOne({ enrollment_number: enrollment_number }, { $set: { password: reqPass } }, (err, dat) => { });

          return rc.setResponse(res, {
            success: true,
            msg: "Data Fetched from dob",
            data: {
              status: true,
              token
            }
          });
        }
        // } else if (studentata.email == reqEmail && studentata.dob == reqDob) {
        //   isVerified = true;
        //   TableModel.updateOne({ enrollment_number: enrollment_number }, { $set: { password: reqPass } }, (err, dat) => { });
        //   return rc.setResponse(res, {
        //     success: true,
        //     msg: "Data Fetched from mobile_number",
        //     data: {
        //       status: true,
        //       token
        //     }
        //   });
        // }
        // else if (studentata.mobile_number == req_mobile_number && studentata.dob == reqDob) {
        //   isVerified = true;
        //   TableModel.updateOne({ enrollment_number: enrollment_number }, { $set: { password: reqPass } }, (err, dat) => { });
        //   return rc.setResponse(res, {
        //     success: true,
        //     msg: "Data Fetched from mobile_number",
        //     data: {
        //       status: true,
        //       token
        //     }
        //   });
        // }
        else {
          isVerified = false;

          return rc.setResponse(res, {
            success: false,
            msg: "dob not match!",
            data: [],
          });
        }
      }
      else {
        return rc.setResponse(res, {
          success: false,
          msg: "student not found!!",
          data: [],
        });
      }
    });
  }
);

router.post(
  "/login",
  (req, res) => {
    const enrollment_number = req.body.enrollment_number;
    const reqPass = req.body.password;
    TableModel.findOne({ enrollment_number: enrollment_number, password: reqPass }, (err, doc) => {
      if (err) {
        return rc.setResponse(res, {
          msg: err.message,
        });
      } else if (doc) {
        let studentata = doc;
        var t_user = {
          id: studentata._id,
          enrollment_no: studentata.enrollment_no,
          dob: studentata.dob
        };
        const token = jwt.sign(t_user, config.secret, {
          expiresIn: 10800
        });
        return rc.setResponse(res, {
          success: true,
          msg: "Data Fetched from enrollment",
          data: {
            status: true,
            token
          }
        });
      }
      else {
        return rc.setResponse(res, {
          success: false,
          msg: "Authentication Failed!!",
          data: [],
        });
      }
    });
  }
);

router.post(
  "/getPaperCodes",
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    const enrollment_number = req.user.enrollment_number;
    TableModel.find({ enrollment_number: enrollment_number }, (err, docs) => {
      if (err) {
        return rc.setResponse(res, {
          msg: err.message,
        });
      } else if (docs && docs.length) {
        let subjects = [];
        for (const doc of docs) {
          subjects = [
            ...subjects,
            doc.papercode1 ? doc.papercode1.trim() : "",
            doc.papercode2 ? doc.papercode2.trim() : "",
            doc.papercode3 ? doc.papercode3.trim() : "",
            doc.papercode4 ? doc.papercode4.trim() : "",
            doc.papercode5 ? doc.papercode5.trim() : "",
            doc.papercode6 ? doc.papercode6.trim() : "",
            doc.papercode7 ? doc.papercode7.trim() : ""
          ];
        }
        let todayStart = new Date();
        todayStart.setHours(0);
        todayStart.setMinutes(0);
        let todayEnd = new Date();
        todayEnd.setHours(23);
        todayEnd.setMinutes(59);

        todayStart.setHours(todayStart.getHours() + 5);
        todayStart.setMinutes(todayStart.getMinutes());
        todayEnd.setHours(todayEnd.getHours() + 5);
        todayEnd.setMinutes(todayEnd.getMinutes() + 30);


        let today_date = new Date();

        // TODO: Uncomment For TimeZone
        // today_date.setHours(today_date.getHours() + 5);
        // today_date.setMinutes(today_date.getMinutes() + 30);
        // console.log(todayStart);
        // console.log(todayEnd);
        // console.log(subjects);
        // TimeTableModel.find({ paper_code: { $in: subjects }, $and: [{ exam_date: { $gte: todayStart } }, { exam_date: { $lte: todayEnd } }] }, (err, timetables) => {
        TimeTableModel.find({ paper_code: { $in: subjects } }, (err, timetables) => {
          if (err) {
            return rc.setResponse(res, {
              msg: err.message,
            });
          } else {
            const paperUploads = [];
            const today = new Date();
            const checkD = today.getDate() + "/" + ((today.getMonth() + 1) < 10 ? "0" : "") + (today.getMonth() + 1) + "/" + today.getFullYear();
            // console.log(subjects);
            // console.log(checkD);
            // console.log(timetables);
            timetables = timetables.filter(o => o.exam_date == checkD)
            for (const ctt of timetables) {
              todaytimetable = ctt;
              let start_time = ctt.exam_start_time.split(":");
              start_time[0] = parseInt(start_time[0]);
              start_time[1] = parseInt(start_time[1]);
              let end_time = ctt.exam_end_time.split(":");
              end_time[0] = parseInt(end_time[0]);
              end_time[1] = parseInt(end_time[1]);

              let isExamPossible = true;
              let reason = '';
              let secs = 20;
              let gap = 90 * 60;
              if (today_date.getHours() < start_time[0]) {
                isExamPossible = false;
                reason = `You are ahead of reporting time, Reporting time is ${start_time[0]}:${start_time[1]}`;
              } else if (today_date.getHours() == start_time[0]) {
                if (today_date.getMinutes() < start_time[1]) {
                  isExamPossible = false;
                  reason = `You are ahead of reporting time, Reporting time is ${start_time[0]}:${start_time[1]}`;
                } else {
                  const minDiff = today_date.getMinutes() - start_time[1];
                  if ((15 - minDiff) > 0) {
                    secs = (15 - minDiff) * 60;
                  }
                  isExamPossible = true;
                }
              } else if (today_date.getHours() < end_time[0]) {
                isExamPossible = true;
              } else if (today_date.getHours() == end_time[0]) {
                console.log(today_date.getHours(), end_time[0]);
                if (today_date.getMinutes() >= end_time[1]) {
                  isExamPossible = false;
                  reason = `Your exam is over at m ${end_time[0]}:${end_time[1]}`;
                } else {
                  isExamPossible = true;
                }
              } else if (today_date.getHours() > end_time[0]) {
                isExamPossible = false;
                reason = `Your exam is over at h ${end_time[0]}:${end_time[1]}`;
              }
              const h_gap = end_time[0] - today_date.getHours();
              const m_gap = today_date.getMinutes() - end_time[1];
              if (h_gap > 0) {
                gap = ((h_gap * 60) - m_gap) * 60;
              } else {
                gap = (m_gap) * 60;
              }
              console.log(reason);
              if (isExamPossible) {
                paperUploads.push(ctt);
              }
            }
            let paperUploadsToSend = paperUploads.map(o => o.paper_code);
            // console.log(paperUploadsToSend);
            let paperToUpload = paperUploadsToSend.filter(o => !(req.user.uploadedPaper.filter(up => up.paper == o)).length);
            // console.log(paperToUpload);
            let papersUploaded = paperUploadsToSend.filter(o => (req.user.uploadedPaper.filter(up => up.paper == o)).length ? true : false);
            // console.log(papersUploaded);

            paperToUpload = [...new Set(paperToUpload)];
            papersUploaded = [...new Set(papersUploaded)];

            return res.json({
              success: true,
              msg: "Data Fetched from enrollment",
              data: paperToUpload,
              papersUploaded: papersUploaded
            });
          }
        })
      }
      else {
        return rc.setResponse(res, {
          success: false,
          msg: "Authentication Failed!!",
          data: [],
        });
      }
    });
  }
);

router.post(
  "/uploadPaper/:paper_code/:pname/:pcode",
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    const enrollment_number = req.user.enrollment_number;
    let rsn = "";
    TableModel.find({ enrollment_number: enrollment_number }, (err, docs) => {
      if (err) {
        return rc.setResponse(res, {
          msg: err.message,
        });
      } else if (docs && docs.length) {
        let subjects = [];
        for (const doc of docs) {
          subjects = [
            ...subjects,
            doc.papercode1 ? doc.papercode1.trim() : "",
            doc.papercode2 ? doc.papercode2.trim() : "",
            doc.papercode3 ? doc.papercode3.trim() : "",
            doc.papercode4 ? doc.papercode4.trim() : "",
            doc.papercode5 ? doc.papercode5.trim() : "",
            doc.papercode6 ? doc.papercode6.trim() : "",
            doc.papercode7 ? doc.papercode7.trim() : ""
          ];
        }
        let todayStart = new Date();
        todayStart.setHours(0);
        todayStart.setMinutes(0);
        let todayEnd = new Date();
        todayEnd.setHours(23);
        todayEnd.setMinutes(59);

        todayStart.setHours(todayStart.getHours() + 5);
        todayStart.setMinutes(todayStart.getMinutes());
        todayEnd.setHours(todayEnd.getHours() + 5);
        todayEnd.setMinutes(todayEnd.getMinutes() + 30);


        let today_date = new Date();

        // TODO: Uncomment For TimeZone
        // today_date.setHours(today_date.getHours() + 5);
        // today_date.setMinutes(today_date.getMinutes() + 30);
        // console.log(todayStart);
        // console.log(todayEnd);
        // console.log(subjects);
        // TimeTableModel.find({ paper_code: { $in: subjects }, $and: [{ exam_date: { $gte: todayStart } }, { exam_date: { $lte: todayEnd } }] }, (err, timetables) => {
        TimeTableModel.find({ paper_code: { $in: subjects } }, (err, timetables) => {
          if (err) {
            return rc.setResponse(res, {
              msg: err.message,
            });
          } else {
            let paperUploads = [];
            const today = new Date();
            const checkD = today.getDate() + "/" + ((today.getMonth() + 1) < 10 ? "0" : "") + (today.getMonth() + 1) + "/" + today.getFullYear();
            // console.log(subjects);
            // console.log(checkD);
            // console.log(timetables);
            timetables = timetables.filter(o => o.exam_date == checkD)
            for (const ctt of timetables) {
              todaytimetable = ctt;
              let start_time = ctt.exam_start_time.split(":");
              start_time[0] = parseInt(start_time[0]);
              start_time[1] = parseInt(start_time[1]);
              let end_time = ctt.exam_end_time.split(":");
              end_time[0] = parseInt(end_time[0]);
              end_time[1] = parseInt(end_time[1]);

              let isExamPossible = true;
              let reason = '';
              let secs = 20;
              let gap = 90 * 60;
              if (today_date.getHours() < start_time[0]) {
                isExamPossible = false;
                reason = `You are ahead of reporting time, Reporting time is ${start_time[0]}:${start_time[1]}`;
              } else if (today_date.getHours() == start_time[0]) {
                if (today_date.getMinutes() < start_time[1]) {
                  isExamPossible = false;
                  reason = `You are ahead of reporting time, Reporting time is ${start_time[0]}:${start_time[1]}`;
                } else {
                  const minDiff = today_date.getMinutes() - start_time[1];
                  if ((15 - minDiff) > 0) {
                    secs = (15 - minDiff) * 60;
                  }
                  isExamPossible = true;
                }
              } else if (today_date.getHours() < end_time[0]) {
                isExamPossible = true;
              } else if (today_date.getHours() == end_time[0]) {
                console.log(today_date.getHours(), end_time[0]);
                if (today_date.getMinutes() >= end_time[1]) {
                  isExamPossible = false;
                  reason = `Your exam is over at m ${end_time[0]}:${end_time[1]}`;
                } else {
                  isExamPossible = true;
                }
              } else if (today_date.getHours() > end_time[0]) {
                isExamPossible = false;
                reason = `Your exam is over at h ${end_time[0]}:${end_time[1]}`;
              }
              const h_gap = end_time[0] - today_date.getHours();
              const m_gap = today_date.getMinutes() - end_time[1];
              if (h_gap > 0) {
                gap = ((h_gap * 60) - m_gap) * 60;
              } else {
                gap = (m_gap) * 60;
              }
              // console.log(reason);
              rsn = reason;
              if (isExamPossible) {
                paperUploads.push(ctt);
              }
            }

            paperUploads = paperUploads.map(o => o.paper_code);
            paperUploads = paperUploads.filter(o => !(req.user.uploadedPaper.filter(up => up.paper == o)).length);
            // if (path.extname((req.files && req.files.length) ? req.files[0] : "") != ".pdf") {
            //   return res.json({ success: false, msg: "Only pdf can be uploaded", data: "" });
            // }

            if ((paperUploads.filter(o => o == req.params.paper_code)).length) {
              singleUploadS3(req, res, (err) => {
                if (err) {
                  console.log(err);
                  return res.json({ success: false, msg: "cant upload", data: "" });
                } else {
                  const newUploadedPaper = {
                    paper: req.params.paper_code,
                    user_pname: req.params.pname,
                    user_pcode: req.params.pcode,
                    file: req.file.location
                  };
                  doc = req.user;
                  doc.real_pass = doc.password;
                  doc.uploadedPaper.push(newUploadedPaper);
                  doc.save((err, std) => {
                    if (err) {
                      console.log(err);
                      return res.json({ success: false, msg: "cant update paper", data: "" });
                    } else {
                      return res.json({ success: true, msg: "successfully uploaded", data: { 'filename': req.file ? req.file.location : '' } });
                    }
                  });
                }
              });
            } else {
              return res.json({ success: false, msg: "cant upload paper right now", data: rsn });
            }
          }
        })
      }
      else {
        return rc.setResponse(res, {
          success: false,
          msg: "Authentication Failed!!",
          data: [],
        });
      }
    });
  }
);

router.get(
  "/totalEnrollments",
  async (req, res) => {
    const data = await TableModel.aggregate([{ "$group": { _id: "$enrollment_number", count: { $sum: 1 } } }]);
    res.json({ count: data ? data.length : 0 });
  }
);

router.get(
  "/papersUploaded",
  async (req, res) => {
    const data = await TableModel.countDocuments({ uploadedPaper: { $exists: true } });
    res.json({ count: data ? data : 0 });
  }
);

router.get(
  "/papers",
  async (req, res) => {
    const data = await TimeTableModel.find({ exam_date: "2020-09-15", exam_start_time: "14:00" }, { paper_code: 1, _id: 0 });
    res.json({ data: data.map(o => o.paper_code) });
  }
);

module.exports = router;

var up = false;

function updatett() {
  console.log("Fired");
  up = true;
  TimeTableModel.find((err, docs) => {
    if (err) {
      return console.log(err);
    }
    let cnt = 0;
    for (const doc of docs) {
      doc.status = "dup";
      TableModel.updateOne({ _id: doc._id }, { $set: doc }, (err, udoc) => {
        if (err) {
          console.log(err);
        } else {
          cnt++;
          console.log(udoc);
        }
      });
    }
  });
}

setTimeout(() => {
  // updatett();
}, 5000);


// db.regstudents.countDocuments(
//   {
//     $or: [
//       { papercode1: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//       { papercode2: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//       { papercode3: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//       { papercode4: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//       { papercode5: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//       { papercode6: { $in: ["PY101A", "PY101B", "PY501", "PY_502", "BP501T", "BT1001", "BT101", "AT501", "AU501", "CE501", "CM501", "CS501", "EC501", "FT501", "EE501", "EX501", "EI501", "IT501", "ME501", "MI501", "AT5001", "AU5001", "CE5001", "CM5001", "CS5001", "EC5001", "EE5001", "FT5001", "EX5001", "EI5001", "IP5001", "IT5001", "ME5001", "MI5001", "TX5001", "BE101", "AU501", "CE501", "CM501", "CS501", "EC501", "EE501", "EI501", "EX501", "FT501", "IP501", "IT501", "ME501", "TX501", "MI501", "AU601", "MPY101", "MVCT101", "MVSE101", "METE101", "MEDC101", "MEMT101", "MEVD101", "MCSE101", "MSE101", "MCTA101", "MCIT101", "MMTP101", "MMIP101", "MMMD101", "MMPD101", "MMIE101", "MEIC101", "MEPE101", "MEHP101", "MEPS101", "MVCT101", "MBCT101", "MVCP101", "MCA101", "MCA501", "BEPT101", "PTEX203", "MAM101", "MAR-111", "MTPA101", "MTPS101", "MMIP101", "MCADD101", "MCADD501", "AR-115", "AR-115", "AR411", "AR411", "AR-111", "AR311", "AR111", "BP101T"] }, },
//     ],
//     uploadedPaper: { $exists: true }
//   })
// db.regstudents.countDocuments(
//   {
//     $or: [
//       { papercode1: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//       { papercode2: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//       { papercode3: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//       { papercode4: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//       { papercode5: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//       { papercode6: { $in: ["PY301", "PY701", "BP301T", "PY_701", "BP701T", "ES301", "BT301", "BT301", "BT301", "ES301", "ES301", "ES301", "BT301", "ES301", "ES301", "ES301", "ES301", "BT301", "BT301", "ES301", "ES3001", "ES3001", "ES3001", "BE3001", "ES3001", "BE3001", "BE3001", "BE3001", "BE3001", "BE3001", "ES3001", "ES3001", "AT7001", "AU7001", "CE7001", "CM7001", "CS7001", "EC7001", "EE7001", "FT7001", "EX7001", "EI7001", "IP7001", "IT7001", "ME7001", "MI7001", "TX7001", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "BE301", "AE701", "AU701", "BM701", "BT701", "CE701", "CM701", "CS701", "EC701", "EE701", "EX701", "EI701", "FT701", "IP701", "IT701", "ME701", "TX701", "MI701", "MCA301", "MCADD301", "AR211", "AR_411"] }, },
//     ],
//     uploadedPaper: { $exists: true }
//   })

//   // 10bje
// db.regstudents.countDocuments(
//   {
//     "uploadedPaper.paper": { $in: [
//       "PY101A","PY101B","BP101T","PY501","PY_502","BP501T","BT1001","BT101","AT501","AT5001","AU5001","CE5001","CM5001","CS5001","EC5001","EE5001","FT5001","EX5001","EI5001","IP5001","IT5001","ME5001","MI5001","TX5001","BE101","IP501","TX501","AU601","MPY101","MVSE101","METE101","MEDC101","MEMT101","MEVD101","MCSE101","MSE101","MCTA101","MCIT101","MMTP101","MMMD101","MMPD101","MMIE101","MEIC101","MEPE101","MEHP101","MEPS101","MBCT101","MVCP101","MCA101","MCA501","BEPT101","PTEX203","MAM101","MAR-111","MTPA101","MTPS101","MCADD101","MCADD501","AR-111","AR311","AR111","AU501","CE501","CM501","CS501","EC501","FT501","EE501","EX501","EI501","IT501","ME501","MI501","MMIP101","MVCT101","AR411","AR-115"
//     ] },
//     uploadedPaper: { $exists: true },
//   }
// )
// // 2 bje
// db.regstudents.countDocuments(
//   {
//     "uploadedPaper.paper": { $in: [
//       "PY301","PY701","BP301T","PY_701","BP701T","ES301","BT301","BE3001","ES3001","AT7001","AU7001","CE7001","CM7001","CS7001","EC7001","EE7001","FT7001","EX7001","EI7001","IP7001","IT7001","ME7001","MI7001","TX7001","BE301","AE701","AU701","BM701","BT701","CE701","CM701","CS701","EC701","EE701","EX701","EI701","FT701","IP701","IT701","ME701","TX701","MI701","MCA301","MCADD301","AR211","AR_411"
//     ] },
//     uploadedPaper: { $exists: true },
//   }
// )
// // 15 tarikh
// db.regstudents.countDocuments(
//   {
//     "uploadedPaper.paper": { $in: [
//       "PY101A","PY101B","BP101T","PY501","PY_502","BP501T","BT1001","BT101","AT501","AT5001","AU5001","CE5001","CM5001","CS5001","EC5001","EE5001","FT5001","EX5001","EI5001","IP5001","IT5001","ME5001","MI5001","TX5001","BE101","IP501","TX501","AU601","MPY101","MVSE101","METE101","MEDC101","MEMT101","MEVD101","MCSE101","MSE101","MCTA101","MCIT101","MMTP101","MMMD101","MMPD101","MMIE101","MEIC101","MEPE101","MEHP101","MEPS101","MBCT101","MVCP101","MCA101","MCA501","BEPT101","PTEX203","MAM101","MAR-111","MTPA101","MTPS101","MCADD101","MCADD501","AR-111","AR311","AR111","AU501","CE501","CM501","CS501","EC501","FT501","EE501","EX501","EI501","IT501","ME501","MI501","MMIP101","MVCT101","AR411","AR-115",
//       "PY301","PY701","BP301T","PY_701","BP701T","ES301","BT301","BE3001","ES3001","AT7001","AU7001","CE7001","CM7001","CS7001","EC7001","EE7001","FT7001","EX7001","EI7001","IP7001","IT7001","ME7001","MI7001","TX7001","BE301","AE701","AU701","BM701","BT701","CE701","CM701","CS701","EC701","EE701","EX701","EI701","FT701","IP701","IT701","ME701","TX701","MI701","MCA301","MCADD301","AR211","AR_411"
//     ] },
//     uploadedPaper: { $exists: true },
//   }
// )

// db.regstudents.countDocuments(
//   {
//     "uploadedPaper.paper": { $nin: [
//       "GU001"
//     ] },
//     uploadedPaper: { $exists: true },
//   }
// )

// "PY101A","PY101B","BP101T","PY501","PY_502","BP501T","BT1001","BT101","AT501","AT5001","AU5001","CE5001","CM5001","CS5001","EC5001","EE5001","FT5001","EX5001","EI5001","IP5001","IT5001","ME5001","MI5001","TX5001","BE101","IP501","TX501","AU601","MPY101","MVSE101","METE101","MEDC101","MEMT101","MEVD101","MCSE101","MSE101","MCTA101","MCIT101","MMTP101","MMMD101","MMPD101","MMIE101","MEIC101","MEPE101","MEHP101","MEPS101","MBCT101","MVCP101","MCA101","MCA501","BEPT101","PTEX203","MAM101","MAR-111","MTPA101","MTPS101","MCADD101","MCADD501","AR-111","AR311","AR111","AU501","CE501","CM501","CS501","EC501","FT501","EE501","EX501","EI501","IT501","ME501","MI501","MMIP101","MVCT101","AR411","AR-115"

// "PY301","PY701","BP301T","PY_701","BP701T","ES301","BT301","BE3001","ES3001","AT7001","AU7001","CE7001","CM7001","CS7001","EC7001","EE7001","FT7001","EX7001","EI7001","IP7001","IT7001","ME7001","MI7001","TX7001","BE301","AE701","AU701","BM701","BT701","CE701","CM701","CS701","EC701","EE701","EX701","EI701","FT701","IP701","IT701","ME701","TX701","MI701","MCA301","MCADD301","AR211","AR_411"
