const student = require('../models/student');
const _ = require('lodash');
const router = require('express').Router();
const Result = require('../models/result').TableModel;
const Student = require('../models/student').TableModel;
const QB = require('../models/question-bank').TableModel;
const TestCreation = require('../models/test-creation').TableModel;
const TestPaper = require('../models/test-paper').TableModel;
var allResult = [];
const helper = require('./../Helpers/handler')
const passport = require('passport');

router.get('/getAllExams', (req, res) => {
    // const exams = await TestCreation.find();
    TestPaper.find({}, (err, results) => {
        if (err) {
            res.json({ success: false, msg: 'Something went wrong!!', err: err })
        } else {
            res.json({ success: true, msg: 'Tests found successfully', exams: results });
        }
    });
    // res.json({success: false, msg: 'Exams / Tests fetched successfully', exams: exams});
});

router.post('/result/query',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        // const label = req.params.term;
        const label = 'result';

        const query = req.body.query;
        // if (req.user.username != 'eams-admin') {
        //     if (label != 'batch' && label != 'course' && label != 'subject') {
        //         if (label == 'timetable') {
        //             query.institute_code = req.user.institute_code;
        //         } else {
        //             // query.created_by = req.user._id;
        //             query.institute_code = req.user.institute_code;
        //         }
        //     }
        // }

        const Table = helper.getModel(label);
        const limit = req.body.limit ? req.body.limit : 10;
        const page = req.body.page ? req.body.page : 1;
        const skip = (page * limit) - limit;

        if (Table) {
            Table.TableModel.countDocuments(query, (err, docsLength) => {
                if (err) {
                    helper.errHandler(res, err);
                } else {
                    Table.TableModel.aggregate([
                        {
                            $match: query,
                        },
                        {
                            $sort: {
                                _id: -1
                            }
                        },
                        {
                            $lookup: {
                                from: 'questionmaps',
                                localField: 'uniqId',
                                foreignField: 'uniqId',
                                as: 'questionmaps'
                            }
                        },
                        {
                            $lookup: {
                                from: 'questionanswers',
                                localField: 'uniqId',
                                foreignField: 'uniqId',
                                as: 'questionanswers'
                            }
                        },
                        {
                            $lookup: {
                                from: 'questionseens',
                                localField: 'uniqId',
                                foreignField: 'uniqId',
                                as: 'questionseens'
                            }
                        }
                    ]
                        , (err, docs) => {
                            if (err) {
                                helper.errHandler(res, err);
                            } else {
                                res.json({
                                    success: true,
                                    msg: 'Data Fetched',
                                    data: {
                                        docs,
                                        docsLength
                                    }
                                });
                            }
                        });
                }
            });
        } else {
            helper.errHandler(res, { message: 'Table Not Found' });
        }
    });

router.get('/getTotalResultsCountOfExam/:examId', (req, res) => {
    const examId = req.params.examId;
    Result.find({ exam_id: examId }).countDocuments().then((resp) => {
        res.json({ success: true, msg: 'count found', count: resp })
    }).catch(err => {
        res.json({ success: false, msg: 'Error', err: err });
    });
});

router.get('/getResultsOfExam/:examId/:page/:limit', (req, res) => {
    const examId = req.params.examId;
    const page = parseInt(req.params.page);
    const limit = parseInt(req.params.limit);
    const skip = parseInt(page * limit - limit);

    // console.log(examId);
    Result.find({ exam_id: examId }, async (err, results) => {
        if (err) {
            return res.json({ success: false, msg: 'Something went wrong!!', err: err });
        } else {
            if (!results.length) {
                return res.json({ success: false, msg: "No Result Found" });
            }
            // console.log('result fetched');
            if (limit > 1000 && allResult.length > 10) {
                res.json({ success: true, msg: 'Result found', result: allResult });
                allResult = [];
                return true;
            }
            let overAllResult = [];
            allQuestions = await QB.find({ _id: { $in: results[0].questions_total } });
            // console.log('que fetched');
            for (let i = 0; i < results.length; i++) {
                // console.log(results[i].student_id);
                let student = await Student.findById(results[i].student_id);
                console.log(i + ' student fetched');
                let answersByStudent = results[i].questions_answered;

                let result = [];
                let totalMarks = 0;
                let scored = 0;
                let allQuestions = [];
                allQuestions = await QB.find({ _id: { $in: results[i].questions_total } });
                let userTestReport = {
                    total_questions: results[i].questions_total.length,
                    total_seen: results[i].questions_seen.length,
                    total_answered: results[i].questions_answered.length,
                    warnings_left: results[i].warnings_left,
                    last_warning: results[i].last_warning,
                    time_left: results[i].time_left,
                    created_at: results[i].created_at,
                    submitted: results[i].submitted,
                    total_correct: 0,
                    total_wrong: 0,
                    total_marks: 0,
                    scored: 0,
                }

                for (const que of allQuestions) {
                    totalMarks += parseInt(que.level);
                    // console.log(que.level);
                }
                // console.log(totalMarks);

                for (let j = 0; j < answersByStudent.length; j++) {
                    let question = await QB.findOne({ _id: answersByStudent[j].qid });
                    if (question.correct_answer == answersByStudent[j].ans) {
                        userTestReport.total_correct = userTestReport.total_correct + 1;
                        scored += parseInt(question.level);
                    } else {
                        userTestReport.total_wrong = userTestReport.total_wrong + 1;
                    }
                }

                userTestReport.total_marks = totalMarks;
                userTestReport.scored = scored;

                let oneResult = {
                    student: student,
                    studentReport: userTestReport
                };
                // if (student) {
                overAllResult.push(oneResult);
                // }
            }
            console.log(overAllResult.length);
            allResult = overAllResult;
            res.json({ success: true, msg: 'Result found', result: overAllResult })
        }
    }).skip(skip).limit(limit);
});

router.post('/getResultsOfExam/:examId/:page/:limit', (req, res) => {
    const examId = req.params.examId;
    const query = req.body.query ? req.body.query : {};
    const page = parseInt(req.params.page);
    const limit = parseInt(req.params.limit);
    const skip = parseInt(page * limit - limit);

    Result.find({ exam_id: examId, "student.enrollment_no": query.enrollment_no }, async (err, results) => {
        if (err) {
            return res.json({ success: false, msg: 'Something went wrong!!', err: err });
        } else {
            // console.log('result fetched');
            if (allResult.length) {
                res.json({ success: true, msg: 'Result found', result: allResult });
                allResult = [];
                return true;
            }
            let overAllResult = [];
            allQuestions = await QB.find({ _id: { $in: results[i].questions_total } });
            // console.log('questions fetched');
            for (let i = 0; i < results.length; i++) {
                let student = await Student.findOne({ _id: results[i].student_id });
                // console.log('student fetched');
                let answersByStudent = results[i].questions_answered;

                let result = [];
                let totalMarks = 0;
                let scored = 0;
                let allQuestions = [];
                let userTestReport = {
                    total_questions: results[i].questions_total.length,
                    total_seen: results[i].questions_seen.length,
                    total_answered: results[i].questions_answered.length,
                    warnings_left: results[i].warnings_left,
                    last_warning: results[i].last_warning,
                    student: results[i].student,
                    time_left: results[i].time_left,
                    created_at: results[i].created_at,
                    submitted: results[i].submitted,
                    total_correct: 0,
                    total_wrong: 0,
                    total_marks: 0,
                    scored: 0,
                }

                for (const que of allQuestions) {
                    totalMarks += parseInt(que.level);
                }

                for (let j = 0; j < answersByStudent.length; j++) {
                    let question = await QB.findOne({ _id: answersByStudent[j].qid });
                    if (question.correct_answer == answersByStudent[j].ans) {
                        userTestReport.total_correct = userTestReport.total_correct + 1;
                        scored += parseInt(question.level);
                    } else {
                        userTestReport.total_wrong = userTestReport.total_wrong + 1;
                    }
                }

                userTestReport.total_marks = totalMarks;
                userTestReport.scored = scored;

                let oneResult = {
                    student: student,
                    studentReport: userTestReport
                };

                if (student) {
                    overAllResult.push(oneResult);
                }
            }
            // console.log(overAllResult.length);
            allResult = overAllResult;
            res.json({ success: true, msg: 'Result found', result: overAllResult })
        }
    }).skip(skip).limit(limit);
});

router.get('/getStudentTestReport/:examId/:studentId', (req, res) => {
    const examId = req.params.examId;
    const studentId = req.params.studentId;


    Result.findOne({ $and: [{ exam_id: studentId }, { student_id: examId }] }, async (err, result) => {
        if (err) {
            return res.json({ success: false, msg: 'error occured', err: err });
        } else {
            let student;
            let overAllQuestions = [];
            let totalAnswered = await result.questions_answered;
            let totalQuestions = [];
            totalQuestions = await QB.find({ _id: { "$in": result.questions_total } });
            try {
                student = await Student.findOne({ _id: examId });
                if (!student) {
                    return res.json({ success: false, msg: 'Student profile not found' })
                }
            } catch (err) {
                return res.json({ success: false, msg: 'Something went wrong!!', err: err });
            }

            for (let i = 0; i < totalQuestions.length; i++) {
                for (let j = 0; j < totalAnswered.length; j++) {
                    if (totalQuestions[i]._id == totalAnswered[j].qid) {
                        let obj = {
                            studentAnswer: totalAnswered[j].ans,//
                            _id: totalQuestions[i]._id,
                            category: totalQuestions[i].category,
                            class_name: totalQuestions[i].class_name,
                            correct_answer: totalQuestions[i].correct_answer,
                            course_name: totalQuestions[i].course_name,
                            image_path: totalQuestions[i].image_path,
                            isCoreRule: totalQuestions[i].isCoreRule,
                            is_image: totalQuestions[i].is_image,
                            level: totalQuestions[i].level,
                            options: totalQuestions[i].options,
                            question: totalQuestions[i].question,
                            status: totalQuestions[i].status,
                            subject_name: totalQuestions[i].subject_name
                        };
                        overAllQuestions.push(obj);
                    }
                }
            }
            for (let i = 0; i < totalQuestions.length; i++) {
                let found = false;
                for (let j = 0; j < overAllQuestions.length; j++) {
                    if (totalQuestions[i]._id == overAllQuestions[j]._id) {
                        found = true;
                    }
                }
                if (found == false) {
                    overAllQuestions.push(totalQuestions[i])
                }
            }
            let TotalAnsweredLength = result.questions_answered.length;
            let TotalQuestionsLength = result.questions_total.length;
            let TotalSeenLength = result.questions_seen.length;
            let TotalSeenIdsArray = result.questions_seen;
            let TotalCorrect = 0;
            let TotalWrong = 0;
            for (let i = 0; i < overAllQuestions.length; i++) {
                if ((overAllQuestions[i].studentAnswer) && (overAllQuestions[i].studentAnswer == overAllQuestions[i].correct_answer)) {
                    TotalCorrect += 1;
                } else if ((overAllQuestions[i].studentAnswer) && (overAllQuestions[i].studentAnswer != overAllQuestions[i].correct_answer)) {
                    TotalWrong += 1;
                }
            }
            res.json({
                success: true, msg: 'report found',
                allQuestions: overAllQuestions, TotalCorrect,
                TotalWrong, TotalAnsweredLength,
                TotalQuestionsLength, TotalSeenLength, TotalSeenIdsArray,
                student: student
            });
        }
    });
});

module.exports = router;