// AWS S3

const aws = require('aws-sdk');
const multer = require('multer');
const multerS3 = require('multer-s3');
const config = require('../config');

aws.config.update({
    secretAccessKey: config.aws_secret_access_key,
    accessKeyId: config.aws_access_key_id
});

const s3 = new aws.S3();

const uploadQuestiosns3 = multer({
    storage: multerS3({
        s3: s3,
        acl: 'public-read',
        bucket: 'rgpv-exam-images',
        metadata: function (req, file, cb) {
            cb(null, { fieldName: file.originalname });
        },
        key: function (req, file, cb) {
            cb(null, 'questions/' + Date.now() + "_" + file.originalname)
        }
    }),
    dest: function (req, file, cb) {
        cb(null, "./questions");
    },
});

const uploadStudentImages3 = multer({
    storage: multerS3({
        s3: s3,
        acl: 'public-read',
        bucket: 'rgpv-exam-images',
        metadata: function (req, file, cb) {
            cb(null, { fieldName: file.originalname });
        },
        key: function (req, file, cb) {
            cb(null, 'studentimages/' + Date.now() + "_" + file.originalname)
        }
    }),
    dest: function (req, file, cb) {
        cb(null, "./studentimages");
    },
});

const uploadPapers3 = multer({
    storage: multerS3({
        s3: s3,
        acl: 'public-read',
        bucket: 'rgpv-exam-images',
        metadata: function (req, file, cb) {
            cb(null, { fieldName: file.originalname });
        },
        key: function (req, file, cb) {
            cb(null, 'paper/' + file.originalname + "_" + Date.now() + ".pdf")
        }
    }),
    dest: function (req, file, cb) {
        cb(null, "./paper");
    },
});

module.exports = uploads3 = { s3, uploadQuestiosns3, uploadStudentImages3, uploadPapers3 };
